#include <Stepper.h>

#define STEPS 100

// photocell
const int photocellFloor1  = A0; // Pin connected to sensor
const int photocellFloor2  = A1;

int sensorValFloor1;
int sensorValFloor2;

// buttons
const int groundFloorPin = 16;
const int floor1Pin = 17;
const int floor2Pin = 18;

// sev seg
const int pinA = 2;
const int pinB = 3;
const int pinC = 4;
const int pinD = 5;
const int pinE = 6;
const int pinF = 7;
const int pinG = 8;
const int D4 = 9;

// Stepper motor pins
const int motorPin1 = 10;
const int motorPin2 = 11;
const int motorPin3 = 12;
const int motorPin4 = 13;

int floorDistance = 2200;
int nextFloor, currentFloor;

Stepper stepper(STEPS, motorPin1, motorPin2, motorPin3, motorPin4);

void printDigit(int x) {
   digitalWrite(D4, LOW);

  if (x == 0) {
    digitalWrite(pinA, HIGH);
    digitalWrite(pinB, HIGH);
    digitalWrite(pinC, LOW);
    digitalWrite(pinD, HIGH);
    digitalWrite(pinE, LOW);
    digitalWrite(pinF, HIGH);
    digitalWrite(pinG, HIGH);
  } else if (x == 1) {
    digitalWrite(pinA, LOW);
    digitalWrite(pinB, HIGH);
    digitalWrite(pinC, HIGH);
    digitalWrite(pinD, LOW);
    digitalWrite(pinE, LOW);
    digitalWrite(pinF, LOW);
    digitalWrite(pinG, LOW);
  }  else if (x == 2) {
    digitalWrite(pinA, LOW);
    digitalWrite(pinB, HIGH);
    digitalWrite(pinC, LOW);
    digitalWrite(pinD, HIGH);
    digitalWrite(pinE, HIGH);
    digitalWrite(pinF, HIGH);
    digitalWrite(pinG, HIGH);
  }
}

void turnOffDigit(){
  digitalWrite(pinA, LOW);
  digitalWrite(pinB, LOW);
  digitalWrite(pinC, LOW);
  digitalWrite(pinD, LOW);
  digitalWrite(pinE, LOW);
  digitalWrite(pinF, LOW);
  digitalWrite(pinG, LOW);
}

void setup() {
  Serial.begin(9600);
  stepper.setSpeed(100);
  
  pinMode(pinA, OUTPUT);
  pinMode(pinB, OUTPUT);
  pinMode(pinC, OUTPUT);
  pinMode(pinD, OUTPUT);
  pinMode(pinE, OUTPUT);
  pinMode(pinF, OUTPUT);
  pinMode(pinG, OUTPUT);
  pinMode(D4, OUTPUT);

  sensorValFloor1 = analogRead(photocellFloor1);
  sensorValFloor2 = analogRead(photocellFloor2);
    
  if (sensorValFloor2 < 25)
    currentFloor = 2;
  else if (sensorValFloor1 < 25)
    currentFloor = 1;
  else
    currentFloor = 0;
  
}

int getFloor() {
  int groundFloor, floor1, floor2;
  while (true) {
    groundFloor = digitalRead(groundFloorPin);
    if(groundFloor == HIGH) {
      Serial.println("Parter");
      return 0;
    }
     
    floor1 = digitalRead(floor1Pin);
    if(floor1 == HIGH) {
      Serial.println("Etaj 1");
      return 1;
     }
     
    floor2 = digitalRead(floor2Pin);
    if(floor2 == HIGH) {
      Serial.println("Etaj2");
      return 2;
     }
  }
}

void getOn(int floorDistance) {
  while (floorDistance){
    stepper.step(1);
    floorDistance--;
 }
  floorDistance = 2200;
}

void getDown(int floorDistance){
  while (floorDistance){
    stepper.step(-1);
    floorDistance--;
  }
  floorDistance = 2200;
}

void loop() {
  printDigit(currentFloor);
  nextFloor = getFloor();
  if (currentFloor == nextFloor)
     Serial.println("Etaj curent");
  else {
    turnOffDigit();
    if (currentFloor == 2) {
      if (nextFloor == 0) {
        floorDistance = floorDistance * 2;
        getDown(floorDistance);
      } else
        getDown(floorDistance + 50);
    } else if (currentFloor == 1) {
      if (nextFloor == 2)
        getOn(floorDistance + 170);
      else if (nextFloor == 0)
        getDown(floorDistance);
    } else {
      if (nextFloor == 2)
        floorDistance = floorDistance * 2;
      getOn(floorDistance);
    }
  }
  currentFloor = nextFloor;
}
